'-- HEADER  ----------------------------------------------------------------------------------------------------------------------
Rem
	bbdoc: Modul zum schnelleren Zugriff auf Farben
End Rem
Module chaos.color
ModuleInfo "Version: 1.02"
ModuleInfo "Author: d-bug"
ModuleInfo "License: Public Domain"
ModuleInfo "Contact: d-bug@chaos-interactive.de"
ModuleInfo "Homepage: www.chaos-interactive.de"

ModuleInfo "History: 1.02 Alpha entfernt"
ModuleInfo "History: 1.01 SetAlpha, SysGetColorFromARGB und SysAGetColorFromARGB knnen jetzt gemischt werden."
ModuleInfo "History: 1.00 Erster Release"

'-- INITIALISIERUNG  --------------------------------------------------------------------------------------------------------
Import brl.max2d

SuperStrict

Global COL_WHITE:TColor =								 	TColor.FromHex ($FFFFFF)
Global COL_BLACK:TColor =								TColor.FromHex ($000000)
Global COL_GREY:TColor =								 	TColor.FromHex ($808080)
Global COL_RED:TColor =									 	TColor.FromHex ($FF0000)
Global COL_GREEN:TColor =								TColor.FromHex ($00FF00)
Global COL_BLUE:TColor =									TColor.FromHex ($0000FF)
Global COL_PINK:TColor = 									TColor.FromHex ($FF00FF)
Global COL_GUI:TColor =										TColor.FromHex ($E8E8E8)
Global COL_GUIHIGH:TColor = 							TColor.FromHex ($3A8BDF)


'----------------------------------------------------------------------------------------------------------------------------------------- TColor
Type TColor

	'----------------------------------------------------------------------------------------------------------------------------------------- Fields
	'#FOLD
	Field Color:Int[3]
	'#UNFOLD

	'----------------------------------------------------------------------------------------------------------------------------------------- IsSameAs
	Method IsSameAs:Byte (SColor:TColor) '#FOLD
		If 	(SColor.Color[0] = Self.Color[0]) And..
		 		(SColor.Color[1] = Self.Color[1]) And..
				(SColor.Color[2] = Self.Color[2])
				Return True
		EndIf
		Return False
	End Method '#UNFOLD

	'----------------------------------------------------------------------------------------------------------------------------------------- AsPaintColor
	Method AsPaintColor () '#FOLD
		.SetColor (Self.Color[0],Self.Color[1],Self.Color[2])
	End Method '#UNFOLD

	'----------------------------------------------------------------------------------------------------------------------------------------- AsCLSColor
	Method AsCLSColor () '#FOLD
		.SetClsColor (Self.Color[0],Self.Color[1],Self.Color[2])
	End Method '#UNFOLD

	'----------------------------------------------------------------------------------------------------------------------------------------- AsMask
	Method AsMask () '#FOLD
		.SetMaskColor (Self.Color[0],Self.Color[1],Self.Color[2])
	End Method '#UNFOLD

	'----------------------------------------------------------------------------------------------------------------------------------------- FromColor
	Function FromPaintColor:TColor () '#FOLD
		Local COL:TColor = New TColor
		.GetColor (COL.Color[0], COL.Color[1], COL.Color[2])
		Return COL
	End Function '#UNFOLD

	'----------------------------------------------------------------------------------------------------------------------------------------- FromClsColor
	Function FromClsColor:TColor () '#FOLD
		Local COL:TColor = New TColor
		.GetClsColor (COL.Color[0], COL.Color[1], COL.Color[2])
		Return COL
	End Function '#UNFOLD

	'----------------------------------------------------------------------------------------------------------------------------------------- FromValue
	Function FromValue:TColor (R:Int,G:Int,B:Int) '#FOLD
		Local COL:TColor = New TColor
		COL.Color[0] = R
		COL.Color[1] = G
		COL.Color[2] = B
		Return COL
	End Function '#UNFOLD

	'----------------------------------------------------------------------------------------------------------------------------------------- FromPixmap
	Function FromPixel:TColor (Pixmap:TPixmap,X:Int, Y:Int) '#FOLD
		Local RGB:Int = Pixmap.ReadPixel(X,Y)
		Return TColor.FromHex (RGB)
	End Function '#UNFOLD

	'----------------------------------------------------------------------------------------------------------------------------------------- FromHex
	Function FromHex:TColor (RGB:Int) '#FOLD
		Local COL:TColor = New TColor
		COL.Color[0] = (RGB Shr 16) & $FF
		COL.Color[1] = (RGB Shr 8) & $FF
		COL.Color[2] = RGB & $FF
		Return COL
	End Function '#UNFOLD

	'----------------------------------------------------------------------------------------------------------------------------------------- ToValue
	Method ToValue (R:Int Var, G:Int Var, B:Int Var) '#FOLD
		R = Self.Color[0]
		G = Self.Color[1]
		B = Self.Color[2]
	End Method '#UNFOLD

	'----------------------------------------------------------------------------------------------------------------------------------------- ToHex
	Method ToHex:Int () '#FOLD
		Return ((Self.Color[0] Shl 16) | (Self.Color[1] Shl 8) | Self.Color[2])
	End Method '#UNFOLD

	'----------------------------------------------------------------------------------------------------------------------------------------- ToString
	Method ToString:String () '#FOLD
		Return Self.Color[0] + "," + Self.Color[1]+"," + Self.Color[2]
	End Method '#UNFOLD

	'----------------------------------------------------------------------------------------------------------------------------------------- Copy
	Method Copy:TColor () '#FOLD
		Return TColor.FromValue (Self.Color[0], Self.Color[1], Self.Color[2])
	End Method '#UNFOLD

	'----------------------------------------------------------------------------------------------------------------------------------------- Red
	Method Red:Int () '#FOLD
		Return Self.Color[0]
	End Method '#UNFOLD

	'----------------------------------------------------------------------------------------------------------------------------------------- Green
	Method Green:Int () '#FOLD
		Return Self.Color[1]
	End Method '#UNFOLD

	'----------------------------------------------------------------------------------------------------------------------------------------- Blue
	Method Blue:Int () '#FOLD
		Return Self.Color[2]
	End Method '#UNFOLD

	'----------------------------------------------------------------------------------------------------------------------------------------- New
	Method New () '#FOLD
		Self.Color[0] = 255
		Self.Color[1] = 255
		Self.Color[2] = 255
	End Method '#UNFOLD

End Type


















